      subroutine init_flow
! modules
      use par_kind
      use outflow_mod

      implicit none


      return
      end






      subroutine init_sup
! modules
      use par_kind
      use lakesup_mod
      use outflow_mod

      implicit none

!
!
!     In case using two-gage eqn, initialize NIZ as level from previous 
!     routing interval, which is start level:
      NIZ = CGSTLV
      IF( NIZ .LT. ZERO) NIZ = ZERO

      MonthLength = 2
      LakesToSolve(1:4)=.true. ! True for Lakes Superior (1), Michigan (2), St-Clair (3) and Erie (4)
      ComputedNonGate=0._wp

      RoutingIncrement(1:2)=0

      RoutingInterval(1) = 4 ! Route through Superior on monthly timestep, Sup Timestep: Monthly
      RoutingInterval(2) = 3 ! Quarter-Monthly Routing through Middle Lakes Using Monthy Supplies Midlake
      StMarysSolution = 3

      P77ACompat = -1 

      Q1887Method = 1
      CritBMethod = 2
      SupCritRnd = 1 ! Sup Criteria Round
         IF( SupCritRnd .EQ. 1) THEN
!            Round Criterion B and C calculations to P77A standards
             CritBOMRound = P77AMONTHROUND
             CritFlowRound = P77AFLOWROUND
             CritLevelRound = P77ALEVELROUND
         ELSE
!            Round Criterion B and C calculations to general settings
             CritBOMRound = BOMRound
             CritFlowRound = FlowRound
             CritLevelRound = LevelRound
         ENDIF

      BOMRound  = -99
      FlowRound = -99
      LevelRound= -99
      LStoSWP=3

      return
      end









      subroutine init_surface
! modules
      use par_kind
      use surface_mod

      implicit none

      integer i,j,k

! FD constant area case
      NUMAVSZ(1:6)=1
      AVSZ(1:6,1,1)=-1._wp
      AVSZ(1,1,2)=82521429480._wp
      AVSZ(2,1,2)=117470753820._wp
      AVSZ(6,1,2)=25692618420._wp
      AVSZ(5,1,2)=1122901542._wp


      end

