      subroutine ccglrrm(ndate, rnf_sup, llsup, llmhu, llstc, &
     &                            lleri, llont, &
     &              outsup, outmhu, outstc, outeri, outont, lwp)
! modules
      use par_kind
      use lakesup_mod
      use outflow_mod

      implicit none
! arguments
      integer ndate
      real(wp) :: rnf_sup
      real(wp) :: llsup, llmhu, llstc, lleri, llont
      real(wp) :: outsup, outmhu, outstc, outeri, outont
      logical  :: lwp
!locals
      real(wp) :: OUTFLOW
      EXTERNAL OUTFLOW
      integer verbose, out_standart

      INTEGER       SecsInRtPeriod(3)
!                   The SecsInRtPeriod value contains the number of
!                   seconds in the current routing interval for each
!                   lake, used for calculating dT.  It gets set once
!                   for weekly, daily, or uniform month/qmonth 
!                   routing, but gets updated each period for actual
!                   month/qmonth routing.

      LOGICAL       NewWeek(3), NewQMonth(3), NewMonth(3)
!                   Indicates that the new routing interval begins
!                   a new week or month.  Note that weeks begin on the
!                   starting day for the simulation.  If routing weekly 
!                   for more than one lake then the periods for both 
!                   lakes must being on the same day of the week.  (You
!                   can't do weekly routing for Lake Superior starting
!                   on monday, and Lake Ontario starting on thursday).
!                   ReadLine indicates that a new summary input line 
!                   should be read in.
      logical, save :: first=.true.
      integer ite, iday, nday, ndm, ndy

      verbose=0
      if(lwp) verbose=1
      out_standart=6

      SupGatesOpen  = -1.0
      dT(1)=3600._wp

! start 1/1/1961

      if (first) then
!       PeriodEnd(1,1)=2 ! month index used in SetUpSupOperationalSupplies
!       PeriodEnd(3,1)=6 ! month index used in SetUpSupOperationalSupplies
!       PeriodEnd(4,1)=2004 ! month index used in SetUpSupOperationalSupplies
       PeriodEnd(4,1)= ndate / 10000 ! month index used in SetUpSupOperationalSupplies
       PeriodEnd(3,1)= (ndate - PeriodEnd(4,1) * 10000 ) / 100 ! month index used in SetUpSupOperationalSupplies
       PeriodEnd(1,1)= ndate - PeriodEnd(4,1) * 10000                  &
     &                        - PeriodEnd(3,1) * 100 ! month index used in SetUpSupOperationalSupplies
       PreviousGates = -9999._wp
       first=.false.
      endif
      RoutingIncrement(1)=24 ! 1 days
      NewMonth(1)=.true. ! FD the only parameter needed for Saint-Marys

!FD update dates:
      nday=RoutingIncrement(1)/24
      iday=PeriodEnd(1,1)
      call NUMDAYS(PeriodEnd(4,1),PeriodEnd(3,1),ndy,ndm)
      do ite = 1, nday
        iday = iday + 1
        if (iday .GT. ndm) then
            PeriodEnd(3,1) = PeriodEnd(3,1) + 1
            if ( PeriodEnd(3,1) .GT. 12 ) then 
                PeriodEnd(3,1) = 1
                PeriodEnd(4,1) = PeriodEnd(4,1) + 1
            endif
            iday=1
        endif
      enddo
      PeriodEnd(1,1)=iday


      SPNTS           = rnf_sup ! m3/s
      PrevStMarysFlow = outsup  !(m3/s) Prev St. M. Riv. Flow

      SPBOMLev = llsup !(m) Sup Start Level 
      MHBOMLev = llmhu !(m) MHu Start Level
      SCBOMLev = llstc !(m) St. C Start Level
      ERBOMLev = lleri !(m) Erie Start Level


      SPSTLV = SPBOMLev !(m) Sup Start Level 
      MHSTLV = MHBOMLev !(m) MHu Start Level
      SCSTLV = SCBOMLev !(m) St. C Start Level
      ERSTLV = ERBOMLev !(m) Erie Start Level

      SPEOP = SPSTLV
      MHEOP = MHSTLV
      SCEOP = SCSTLV
      EREOP = ERSTLV
      ONEOP = ONSTLV

      NominalStMarys = DBLE(PrevStMarysFlow)


!     XX make SolutionTest user-defined (ie, avoid warning 
!     XX message if below 1tcfs, etc)
      IF( FlowRound .LE. -2) THEN
         SolutionTest = ONE / TEN
      ELSE
         SolutionTest = 10.0_wp**FlowRound
      ENDIF

      call compute_saint_marys(NewMonth(1),verbose)

      outsup = STMRIVFLOW

! test between Superior and Huron-Michigan
!      outsup = OUTFLOW(SPBOMLev, MHBOMLev,
!     &         P77ASPK, P77ASPYM, P77ASPA, P77ASPB, P77ASPWT, P77ASPC)

! test between Huron-Michigan and St-Clair
      outmhu = OUTFLOW(MHBOMLev, SCBOMLev,                              &
     &         P77AMHK, P77AMHYM, P77AMHA, P77AMHB, P77AMHWT, P77AMHC)  &
     &  - SCRRet(PeriodEnd(3,1))

! test between St-Clair and Erie
      outstc = OUTFLOW( SCBOMLev, ERBOMLev,                             &
     &         P77ASCK, P77ASCYM, P77ASCA, P77ASCB, P77ASCWT, P77ASCC)
!     &  - DetRet(PeriodEnd(3,1))

! test between Erie and Ontario
      outeri = OUTFLOW( ERBOMLev, P77ACGIP,                             &
     &         P77AERK, P77AERYM, P77AERA, P77AERB, P77AERWT, P77AERC)
!     &  - NiaRet(PeriodEnd(3,1))

! from WatRoute
      outont=555.823_wp*                                                &
     &(llont-0.0014_wp*dble(2000-1985)-69.474_wp)**1.5_wp
!     &           -retard_factor(mo1,5)
      end






      SUBROUTINE IncrementDates(Lake, SecsInPeriod, &
     &    NewWeek, NewQMonth, NewMonth)
! modules
      use par_kind
      use lakesup_mod
      use outflow_mod

      IMPLICIT NONE 
!
!     Declarations regarding function arguments:
!
      INTEGER       Lake
!                   1 for Lake Superior, 2 for middle lakes, 3 for
!                   Lake Ontario
!
      INTEGER       SecsInPeriod
!                   Number of seconds in the routng period
!
      LOGICAL       NewWeek, NewQMonth, NewMonth
!                   True if period starts a new one
!
!     Declarations regarding local variables or functions:
!
      INTEGER       I
!                   Scratch
!
      INTEGER       DaysToAdd(2)
!                   For daily and weekly routing. 
!
      CHARACTER*13  NameOfLake(3)
!
!
      DATA DaysToAdd / 1, 7 /
!
      DATA NameOfLake /'Lake Superior','Middle Lakes ','Lake Ontario '/
!
!
!     Update day (beginning of new routing period) to be the day after 
!     current period ends
      Day(Lake) = PeriodEnd(1,Lake) + 1
!     If past end of a month, adjust date
      IF(Day(Lake) .GT. Q(4,Lake)) Day(Lake) = 1
!
      IF( RoutingInterval(Lake) .LE. 2 ) THEN
!
!        Daily or weekly routing - increment by DaysToAdd
!        Compute elapsed days at end of new routing interval
         PeriodEnd(5,Lake) = PeriodEnd(5,Lake) +  &
     &      DaysToAdd(RoutingInterval(Lake))
!        Compute elapsed days at end of routing interval after new one
         PeriodEnd(6,Lake) = PeriodEnd(5,Lake) +  &
     &      DaysToAdd(RoutingInterval(Lake))
!
!        Update day of month for end of new period
         PeriodEnd(1,Lake) = PeriodEnd(1,Lake) +  &
     &      DaysToAdd(RoutingInterval(Lake))
!
!
         IF( RoutingInterval(Lake) .EQ. 1 ) THEN
!           If daily routing and after first period, turn off NewMonth, etc
            IF( PeriodEnd(5,Lake) .GT. 1 )THEN
               NewWeek = .FALSE.
               NewQMonth = .FALSE.
               NewMonth = .FALSE.
!              If were routing daily through Ontario under P58D, then
!              would need to add DaysSinceSaturday to PeriodEnd(5,?)
               IF( MOD(PeriodEnd(5,Lake), 7) .EQ. 0) NewWeek = .TRUE.
            ENDIF
         ELSE
            NewWeek = .TRUE.
         ENDIF
!
!        See if new ending date is greater than end of current
!        quartermonth number=PeriodEnd(2,Lake)
         IF(PeriodEnd(1,Lake) .GT. Q(PeriodEnd(2,Lake),Lake)) THEN
            NewQMonth = .TRUE.
            PeriodEnd(2,Lake) = PeriodEnd(2,Lake) + 1
!
!           Check to see if new month
            IF(PeriodEnd(2,Lake) .GT. 4) THEN
               NewMonth = .TRUE.
               PeriodEnd(2,Lake) = 1
!              Adjust date
               PeriodEnd(1,Lake) = PeriodEnd(1,Lake) - Q(4,Lake)
               PeriodEnd(3,Lake) = PeriodEnd(3,Lake) + 1
!
!              Check to see if new year
               IF(PeriodEnd(3,Lake) .GT. 12 ) THEN
                  PeriodEnd(3,Lake) = 1
                  PeriodEnd(4,Lake) = PeriodEnd(4,Lake) + 1
               ENDIF
!
!              Update Q array for the lake
               CALL GetQtrMonBounds( PeriodEnd(4,Lake), &
     &            PeriodEnd(3,Lake), Q(1,Lake))
            ELSE
               NewMonth = .FALSE.
            ENDIF
         ELSE
            NewQMonth = .FALSE.
            NewMonth = .FALSE.
         ENDIF
!        Oops!  Check to see if first time through:
         IF(PeriodEnd(5,Lake) .EQ. DaysToAdd(RoutingInterval(Lake)))THEN
            NewQMonth = .TRUE.
            NewMonth = .TRUE.
            NewWeek = .TRUE.
         ENDIF          
!
      ELSE IF( RoutingInterval(Lake) .EQ. 3 ) THEN
!        Quarter-monthly routing
         NewWeek = .TRUE.
         NewQMonth = .TRUE.
         PeriodEnd(2,Lake) = PeriodEnd(2,Lake) + 1
!
!        Check to see if new month (or 1st month of run)
         IF(PeriodEnd(2,Lake) .GT. 4 ) THEN
            NewMonth = .TRUE.
            PeriodEnd(2,Lake) = 1
            PeriodEnd(3,Lake) = PeriodEnd(3,Lake) + 1
!           Check to see if new year
            IF(PeriodEnd(3,Lake) .GT. 12 ) THEN
               PeriodEnd(3,Lake) = 1
               PeriodEnd(4,Lake) = PeriodEnd(4,Lake) + 1
            ENDIF
!           Update Q array for the lake
            CALL GetQtrMonBounds( PeriodEnd(4,Lake),        &
     &            PeriodEnd(3,Lake), Q(1,Lake))
         ELSE 
            NewMonth = .FALSE.
         ENDIF
!
!        Set the date for end of quarter-month
         PeriodEnd(1,Lake) = Q( PeriodEnd(2,Lake) ,Lake)
!
!        Set NewMonth if first time 
         IF(PeriodEnd(5,Lake) .EQ. 0) NewMonth = .TRUE.
!
!        Adjust days elapsed to end of period
         PeriodEnd(5,Lake) = PeriodEnd(5,Lake) +            &
     &      (PeriodEnd(1,Lake) - Day(Lake) + 1)
!        Adjust days elapsed to end of next period.  Put length of next
!        period in I
         IF( PeriodEnd(2,Lake) .EQ. 4)THEN
!           Next quarter-month will be in new month.  First quarter of 
!           February is 7 days long; all other months first quarter is 
!           8 days long.  So see if next month will be Feb:
            IF( PeriodEnd(3,Lake) .EQ. 1) THEN
               I = 7
            ELSE
               I = 8
            ENDIF
         ELSE
!           Next quarter-month in same month, just subtract dates in Q
            I= Q(PeriodEnd(2,Lake) +1, Lake) - Q(PeriodEnd(2,Lake),Lake)
         ENDIF
         PeriodEnd(6,Lake) = PeriodEnd(5,Lake) + I
!
!
      ELSE IF( RoutingInterval(Lake) .EQ. 4 ) THEN
!        Monthly routing
         NewWeek = .TRUE.
         NewQMonth = .TRUE.
         NewMonth = .TRUE.
         PeriodEnd(2,Lake) = 4
         PeriodEnd(3,Lake) = PeriodEnd(3,Lake) + 1
!        Check to see if new year
         IF(PeriodEnd(3,Lake) .GT. 12 ) THEN
            PeriodEnd(3,Lake) = 1
            PeriodEnd(4,Lake) = PeriodEnd(4,Lake) + 1
         ENDIF
!        Update Q array for the lake
         CALL GetQtrMonBounds( PeriodEnd(4,Lake),  &
     &            PeriodEnd(3,Lake), Q(1,Lake))
!        Set the date for end of month
         PeriodEnd(1,Lake) = Q( 4, Lake)
         PeriodEnd(5,Lake) = PeriodEnd(5,Lake) +   &
     &      (PeriodEnd(1,Lake) - Day(Lake) + 1)
!
         IF(PeriodEnd(3,Lake) .EQ. 12 ) THEN
            PeriodEnd(6,Lake) = PeriodEnd(6,Lake) + 31
         ELSE         
!           Don't need number of days in year; use I as scratch
            CALL NUMDAYS(PeriodEnd(4,Lake), PeriodEnd(3,Lake) + 1, &
     &         I, PeriodEnd(6,Lake))
            PeriodEnd(6,Lake) = PeriodEnd(6,Lake) + PeriodEnd(5,Lake)
         ENDIF
      ENDIF
! 
!
      IF(MonthLength .EQ. 2 .AND. RoutingInterval(Lake) .GE. 3) THEN
!        Actual quarter-month or month length
         SecsInPeriod = (PeriodEnd(1,Lake) - Day(Lake) + 1) * 86400
!        Adjust number of increments if keeping dT at 1 hour
         IF( NumIncsVary(Lake) ) RoutingIncrement(Lake) =  &
     &      SecsInPeriod / 3600
         dT(Lake)= DBLE(SecsInPeriod)/DBLE(RoutingIncrement(Lake))
         I = 20
      ENDIF
      END
!----&------------------------------------------------------------------
!----&------------------------------------------------------------------


