! FD comments:
! FD incomplete because
! FD missing values for some variables defined in common blocks
! FD unknown routines

!----------------------------------------------------------------------
!
!
      FUNCTION OUTFLOW(ZU,ZD,K,YM,A,B,WT,ZC)
!
! modules
      USE par_kind
!
      IMPLICIT NONE
!
! arguments
      real(wp) :: OUTFLOW
      real(wp) :: ZU,ZD,ZC,K,YM,WT,A,B
!      INTEGER      Verbosity,file_unit
! locals
      real(wp) :: ONE
!
!  Given constants k, ym, a, and b, and variables zu and zd, 
!  calculate channel outflow.  Terms include:
!         zu = upstream lake elevation
!         zd = downstream lake elevation
!         ZC = fall constant
!         k = outflow equation coefficient
!         ym = outlet bottom elevation
!         a = depth exponent
!         b = fall exponent
!         wt = relative weight between upstream and downstream lake levels
!  The constants k, ym, a, and b are dictated by the stage-discharge 
!  relationship for each connecting channel.  This function was written by
!  Anne H. Clites, NOAA/GLERL, September, 1995.  The ZC variable was added
!  by Matt in order to accommodate the metric forms of the equations.
!
!
      ONE=1._wp

!     Error checking.
!
!     TODO:  read in a range for which the equation is valid, test 
!            and issue warning if outside calibrated range.
      IF (ZD .GE. (ZU+ZC) .OR. YM .GT. ZU) THEN
         WRITE(*,5387) ZU, YM, ZD
 5387    FORMAT(' Upstream level:',F8.4,' Channel invert:',F8.4, &
     &      '  Downstream level:',F8.4)
      ENDIF
!
!
      OUTFLOW = K* (WT*ZU+(ONE-WT)*ZD-YM)**A * (ZU-ZD+ZC)**B
!
!
!      IF( Verbosity .gt. 0) THEN                          
!         WRITE(file_unit,5444) K, WT, YM, ZC, A, B
!         WRITE(file_unit,5445) ZU, ZD, OUTFLOW,
!     & (WT*ZU+(ONE-WT)*ZD-YM)**A
! 5444   FORMAT(5X, 'Outflow Eqn: ', ' K=', F11.7, ' WT=', F5.3, ' YM=', 
!     &     F12.7, ' ZC=', F5.3,' A=', F15.12, ' B=', F15.12)
! 5445   FORMAT(5X, 'Input/Output: ', ' ZU=',F15.11,' ZD=', F15.11, 
!     &     ' Outflow=', F15.8, ' Depth term=', F15.11)
!      ENDIF
!
      END

